"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _reactDom = _interopRequireDefault(require("react-dom"));

var _history = require("history");

var _invariant = _interopRequireDefault(require("invariant"));

var _utils = require("./utils");

var _types = require("./types");

var _redux = _interopRequireDefault(require("./redux"));

var _logger = _interopRequireDefault(require("./logger"));

var _App = _interopRequireDefault(require("./App"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

var defaultOpts = {
  historyType: _types.HistoryType.BROWSER
};

function _default() {
  var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultOpts;
  var onEffect = opts.onEffect,
      onFetchOption = opts.onFetchOption,
      onReducer = opts.onReducer,
      historyType = opts.historyType;
  var history;

  switch (historyType) {
    case _types.HistoryType.HASH:
      history = (0, _history.createHashHistory)();
      break;

    case _types.HistoryType.BROWSER:
      history = (0, _history.createBrowserHistory)();
      break;

    default:
      history = (0, _history.createBrowserHistory)();
      break;
  }

  var options = {
    setupApp: function setupApp(app) {
      app.history = (0, _utils.patchHistory)(history);

      if (window.__INITIAL_WORKER_PATH__) {
        try {
          var path = window.__INITIAL_WORKER_PATH__;

          _logger["default"].start(path);
        } catch (e) {
          console.error('parse window initial logger path error -> ', e);
        }
      }
    },
    onEffect: onEffect,
    onFetchOption: onFetchOption,
    onReducer: onReducer,
    history: history
  };
  var app = (0, _redux["default"])(options);
  var appStart = app.rStart;
  app.router = router;
  app.start = start;
  return app;

  function render(container, store, app) {
    _reactDom["default"].render((0, _App["default"])(app), container);
  }

  function start(container) {
    if (typeof container === 'string') {
      container = document.querySelector(container);
      (0, _invariant["default"])(container, "[app.start] container ".concat(container, " not found"));
    }

    (0, _invariant["default"])(!container || (0, _utils.isHTMLElement)(container), "[app.start] container should be HTMLElement");
    (0, _invariant["default"])(app._router, "[app.router] router must be registered before app.start()");

    if (!app.store) {
      appStart(app);
    }

    var store = app.store;

    if (container) {
      return render(container, store, app);
    } else {
      return (0, _App["default"])(app);
    }
  }

  function router(router) {
    (0, _invariant["default"])((0, _utils.isFunction)(router), "[app.router] router should be function, but got ".concat(_typeof(router)));
    app._router = router;
  }
}