"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Logger = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

var Logger = /*#__PURE__*/function () {
  function Logger() {
    _classCallCheck(this, Logger);
  }

  _createClass(Logger, null, [{
    key: "checkWork",
    value: // ------------------------- methods ------------------------------
    function checkWork() {
      return !!this.worker;
    }
  }, {
    key: "getTime",
    value: function getTime(type) {
      var timeStamp;

      switch (type) {
        case 'millisecond':
          timeStamp = new Date().getTime();
          break;

        case 'second':
          timeStamp = Date.parse(new Date()) / 1000;
          break;

        default:
          timeStamp = Date.parse(new Date()) / 1000;
      }

      return timeStamp;
    } // --------------------------- worker ---------------------------------

  }, {
    key: "start",
    value: function start(path) {
      if (!window.SharedWorker) {
        console.error('Check if Browser supports the Worker api.');
      }

      if (!path) {
        console.error('please provide the url of worker.js');
        return;
      }

      this.worker = new SharedWorker(path);
    }
  }, {
    key: "info",
    value: function info(params, options) {
      if (!this.checkWork()) {
        console.error('please run Logger.start() first');
        return;
      }

      if (params.hasOwnProperty('eventTime')) {
        this.worker.port.postMessage(params);
      } else {
        this.worker.port.postMessage(Object.assign(Object.assign({}, params), {
          eventTime: this.getTime(options === null || options === void 0 ? void 0 : options.timeStamp)
        }));
      }
    }
  }, {
    key: "onMessage",
    value: function onMessage(func) {
      if (!this.checkWork()) {
        console.error('please run Logger.start() first');
        return;
      }

      this.worker.port.onmessage = function (e) {
        func && func(e);
      };
    }
  }]);

  return Logger;
}();

exports.Logger = Logger;
var _default = Logger;
exports["default"] = _default;