"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

var _default = function _default(initialState, handlers) {
  if (initialState === undefined && initialState === null) {
    throw new Error('Initial state is required');
  }

  if (_typeof(handlers) !== 'object') {
    throw new Error('Handlers must be an object');
  }

  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
    var action = arguments.length > 1 ? arguments[1] : undefined;

    if (!action || !Object.prototype.hasOwnProperty.call(action, 'type')) {
      return state;
    }

    var handler = handlers[action.type];
    var newState = !handler ? state : handler(state, action);

    if (!action.type.endsWith('_FAIL')) {
      delete newState.error;
    }

    return newState;
  };
};

exports["default"] = _default;