"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;

var _redux = require("redux");

function _default() {
  var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var reducers = opts.reducers,
      initialState = opts.initialState,
      sagaMiddleware = opts.sagaMiddleware;

  var devTools = function devTools(p) {
    return function (noop) {
      return noop;
    };
  };

  if (process.env.NODE_ENV !== 'production' && window.__REDUX_DEVTOOLS_EXTENSION__) {
    devTools = window.__REDUX_DEVTOOLS_EXTENSION__;
  }

  var middlewares = [sagaMiddleware];
  var option = window.__REDUX_DEVTOOLS_EXTENSION__OPTIONS;
  var enhancers = [_redux.applyMiddleware.apply(void 0, middlewares), devTools(option)];
  return (0, _redux.createStore)(reducers, initialState, _redux.compose.apply(void 0, enhancers));
}