"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports._models_ = void 0;
exports["default"] = create;

var _reduxSaga = _interopRequireDefault(require("redux-saga"));

var _jsBase = require("js-base64");

var _createStore = _interopRequireDefault(require("./createStore"));

var _reducerBuilder = require("./reducerBuilder");

var _sagaBuilder = require("./sagaBuilder");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var cSagaMiddleware = _reduxSaga["default"];

var _models_ = Symbol('_models_');

exports._models_ = _models_;

function create(createOpts) {
  var _app;

  var setupApp = createOpts.setupApp,
      onEffect = createOpts.onEffect,
      onFetchOption = createOpts.onFetchOption,
      onReducer = createOpts.onReducer,
      history = createOpts.history;
  var app = (_app = {}, _defineProperty(_app, _models_, []), _defineProperty(_app, "model", model), _defineProperty(_app, "models", models), _defineProperty(_app, "rStart", rStart), _app);

  function model(model) {
    app[_models_] = [].concat(_toConsumableArray(app[_models_]), [model]);
  }

  function models(models) {
    app[_models_] = [].concat(_toConsumableArray(app[_models_]), _toConsumableArray(models));
  }

  function rStart(app) {
    var sagaMiddleware = cSagaMiddleware();
    var initialState = {};

    if (window.__INITIAL_STATE__) {
      try {
        initialState = JSON.parse(_jsBase.Base64.decode(window.__INITIAL_STATE__)) || {};
      } catch (e) {
        console.error('parse window initial state error -> ', e);
      }
    }

    app.store = (0, _createStore["default"])({
      reducers: (0, _reducerBuilder.reducerBuilder)(app[_models_], onReducer),
      initialState: initialState,
      sagaMiddleware: sagaMiddleware
    });
    app.store.runSaga = sagaMiddleware.run;
    var sagas = (0, _sagaBuilder.sagaBuilder)(app[_models_], {
      onEffect: onEffect,
      onFetchOption: onFetchOption,
      history: history
    });
    sagaMiddleware.run(sagas);
    setupApp(app);
  }

  return app;
}