"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isFunction = exports.isArray = void 0;
exports.isHTMLElement = isHTMLElement;
exports.patchHistory = exports.onError = exports.onEffect = exports.isString = void 0;

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

var patchHistory = function patchHistory(history) {
  var oldListen = history.listen;

  history.listen = function (callback) {
    callback(history.location);
    return oldListen.call(history, callback);
  };

  return history;
};

exports.patchHistory = patchHistory;

var isFunction = function isFunction(o) {
  return typeof o === 'function';
};

exports.isFunction = isFunction;

var isString = function isString(o) {
  return typeof o === 'string';
};

exports.isString = isString;
var isArray = Array.isArray.bind(Array);
exports.isArray = isArray;

function isHTMLElement(node) {
  return _typeof(node) === 'object' && node !== null && node.nodeType && node.nodeName;
}

var onError = function onError(app, _onError) {
  return function (err) {
    if (err) {
      if (typeof err === 'string') {
        err = new Error(err);
      }

      if (_onError && typeof _onError === 'function') {
        _onError(err, app.store.dispatch);

        throw new Error(err.stack || err);
      }
    }
  };
};

exports.onError = onError;

var onEffect = function onEffect() {};

exports.onEffect = onEffect;