import { applyMiddleware, compose, createStore } from 'redux';
export default function (opts = {}) {
    const { reducers, initialState, sagaMiddleware } = opts;
    let devTools = (p) => (noop) => noop;
    if (process.env.NODE_ENV !== 'production' &&
        window.__REDUX_DEVTOOLS_EXTENSION__) {
        devTools = window.__REDUX_DEVTOOLS_EXTENSION__;
    }
    const middlewares = [sagaMiddleware];
    const option = window.__REDUX_DEVTOOLS_EXTENSION__OPTIONS;
    const enhancers = [applyMiddleware(...middlewares), devTools(option)];
    return createStore(reducers, initialState, compose(...enhancers));
}
